/* 
The NIST RCS (Real-time Control Systems) 
 library is public domain software, however it is preferred
 that the following disclaimers be attached.

Software Copywrite/Warranty Disclaimer

   This software was developed at the National Institute of Standards and
Technology by employees of the Federal Government in the course of their
official duties. Pursuant to title 17 Section 105 of the United States
Code this software is not subject to copyright protection and is in the
public domain. NIST Real-Time Control System software is an experimental
system. NIST assumes no responsibility whatsoever for its use by other
parties, and makes no guarantees, expressed or implied, about its
quality, reliability, or any other characteristic. We would appreciate
acknowledgement if the software is used. This software can be
redistributed and/or modified freely provided that any derivative works
bear some notice that they are derived from it, and any modified
versions bear some notice that they have been modified.



*/ 

/* This file "rcs_config.h."  Generated by configure, 
* but then manually edited for the Microsoft Windows platform with
* Visual C++ 6.0 or better.
*/

/* rcs_config.h.in.  Generated from configure.ac by autoheader.  */

// The following came from rpatel@gdrs.com -- Rcslib_Tweaks_for_GDRS.doc 
// It enables a replace of strdup with _strdup in cms_cfg.cc
#define USE__STRDUP 1


/* What platform is this built for? */
#define BUILD_PLATFORM "x86-pc-mswindows"

/* MSVC is f'd up again, I should be able to include the headers in either order. */
#define WINSOCK_BEFORE_WINDOWS

/* Define to 1 if packed encoding support in rcslib is enabled. */
#define ENABLE_PACKED_UP 1

/* Define to 1 if nmlqr support in rcslib is enabled. */
/* #undef ENABLE_RCS_CMS_MRPQ */

/* Define to 1 if crypt2 support in rcslib is enabled. */
/* #undef ENABLE_RCS_CRYPT2 */

/* Define to 1 if diag support in rcslib is enabled. */
/* #undef ENABLE_RCS_DIAG */

/* Define to 1 if disp support in rcslib is enabled. */
#define ENABLE_RCS_DISP 1

/* Define to 1 if filemem is enabled. */
/* #undef ENABLE_RCS_FILEMEM */

/* Define to 1 if http support in rcslib is enabled. */
/* ENABLE_RCS_HTTP */

/* Define to 1 if inifile support in rcslib is enabled. */
#define ENABLE_RCS_INIFILE 1

/* Define to 1 if locmem support in rcslib is enabled. */
/* #undef ENABLE_RCS_LOCMEM */

/* Define to 1 if nmlcfgsvr is enabled. */
#define ENABLE_RCS_NMLCFGSVR 1

/* Define to 1 if nmlmod is enabled. */
#define ENABLE_RCS_NMLMOD 1

/* Define to 1 if nmlqr support in rcslib is enabled. */
#define ENABLE_RCS_NMLQR 1

/* Define to 1 if sokintrf support in rcslib is enabled. */
/* #undef ENABLE_RCS_OE_INTRF */

/* Define to 1 if packedl64 encoding support in rcslib is enabled. */
#define ENABLE_RCS_PACKEDL64 1

/* Define to 1 if phantommem support in rcslib is enabled. */
/* #undef ENABLE_RCS_PHANTOMMEM */

/* Define to 1 if rcs_prnt support in rcslib is enabled. */
#define ENABLE_RCS_PRNT 1

/* Define to 1 if rtlmem support in rcslib is enabled. */
/* #undef ENABLE_RCS_RTLMEM */

/* Define to 1 if server support in rcslib is enabled. */
#define ENABLE_RCS_SERVER 1

/* Define to 1 if shmem is enabled. */
#define ENABLE_RCS_SHMEM 1

/* Define to 1 if sokintrf support in rcslib is enabled. */
#define ENABLE_RCS_SOKINTRF 1

/* Define to 1 if stcp support in rcslib is enabled. */
#define ENABLE_RCS_STCP 1

/* Define to 1 if tcp support in rcslib is enabled. */
#define ENABLE_RCS_TCP 1

/* Define to 1 if tty support in rcslib is enabled. */
#define ENABLE_RCS_TTY 1

/* Define to 1 if udp support in rcslib is enabled. */
#define ENABLE_RCS_UDP 1

/* Define to 1 if xdr support in rcslib is enabled. */
#define ENABLE_RCS_XDR 1

/* Define to 1 if xml support in rcslib is enabled. */
#define ENABLE_RCS_XML 1

/* Define to 1 if you have the `abort' function. */
#define HAVE_ABORT 1

/* if we should use the adafinal funtion */
/* #undef HAVE_ADAFINAL */

/* if we should use the adainit funtion */
/* #undef HAVE_ADAINIT */

/* Define to 1 if you have <arpa/inet.h> */
/* #undef HAVE_ARPA_INET_H */

/* Define to 1 if you have the caddr_t type. */
/* #undef HAVE_CADDR_T_TYPE */

/* Define to 1 if you have the `clock_gettime' function. */
/* #undef HAVE_CLOCK_GETTIME */

/* Define to 1 if you have the CloseHandle function. */
#define HAVE_CLOSEHANDLE 1

/* Define to 1 if you have the CreateFileMapping function. */
#define HAVE_CREATEFILEMAPPING 1

/* Define to 1 if you have the CreateMutex function. */
#define HAVE_CREATEMUTEX 1

/* Define to 1 if you have the <ctype.h> header file. */
#define HAVE_CTYPE_H 1

/* Define to 1 if you have the <dirent.h> header file, and it defines `DIR'.
   */
/* #undef HAVE_DIRENT_H */

/* Define to 1 if you have the <dlfcn.h> header file. */
/* #undef HAVE_DLFCN_H */

/* Define to 1 if you have the <dos.h> header file. */
#define HAVE_DOS_H 1

/* Define to 1 if you have the <errno.h> header file. */
#define HAVE_ERRNO_H 1

/* Define to 1 if you have < fcntl.h> */
#define HAVE_FCNTL_H 1

/* Define to 1 if you have the <float.h> header file. */
#define HAVE_FLOAT_H 1

/* Define to 1 if you have the `fstat' function. */
#define HAVE_FSTAT 1

/* Define to 1 if you have the `stat' function. */
#define HAVE_STAT 1

/* Define to 1 if you have the `getcwd' function. */
#define HAVE_GETCWD 1

/* Define to 1 if you have the `getenv' function. */
#define HAVE_GETENV 1

/* Define to 1 if you have the `gethostbyaddr' function. */
/* #undef HAVE_GETHOSTBYADDR */

/* Define to 1 if you have the `gethostbyname' function. */
/* #undef HAVE_GETHOSTBYNAME */

/* Define to 1 if you have the `gethostbyname_r' function. */
/* #undef HAVE_GETHOSTBYNAME_R */

/* Define to 1 if you have the `gethostname' function. */
/* #undef HAVE_GETHOSTNAME */

/* Define to 1 if you have the `getsockopt' function. */
/* #undef HAVE_GETSOCKOPT */

/* Define to 1 if you have the GetTickCount function. */
#define HAVE_GETTICKCOUNT 1

/* Define to 1 if you have the `gettimeofday' function. */
/* #undef HAVE_GETTIMEOFDAY */

/* Define to 1 if you have the `getwd' function. */
/* #undef HAVE_GETWD */

/* Define to 1 if you have the GetCurrentProcessId function */
#define HAVE_GET_CURRENT_PROCESS_ID 1

/* Define to 1 if you have the GetCurrentThreadId function */
#define HAVE_GET_CURRENT_THREAD_ID 1

/* Define to 1 if you have the `inet_ntoa' function. */
/* #undef HAVE_INET_NTOA */

/* Define to 1 if you have the InitializeSecurityDescriptor function. */
#define HAVE_INITIALIZESECURITYDESCRIPTOR 1

/* Define to 1 if you have <inttypes.h> */
#define HAVE_INTTYPES_H 1

/* Define to 1 if you have the <iostream.h> header file. */
/* #undef HAVE_IOSTREAM_H */

/* Define to 1 if you have the <io.h> header file. */
#define HAVE_IO_H 1

/* Define to 1 if you have the key_t type. */
/* #undef HAVE_KEY_T_TYPE */

/* Define to 1 if you have the `gccprefix' library (-lgccprefix). */
/* #undef HAVE_LIBGCCPREFIX */

/* Define to 1 if you have the `gmem' library (-lgmem). */
/* #undef HAVE_LIBGMEM */

/* Define to 1 if you have the `gnarl' library (-lgnarl). */
/* #undef HAVE_LIBGNARL */

/* Define to 1 if you have the `gnat' library (-lgnat). */
/* #undef HAVE_LIBGNAT */

/* Define to 1 if you have the `m' library (-lm). */
#define HAVE_LIBM 1

/* Define to 1 if you have the `nsl' library (-lnsl). */
/* #undef HAVE_LIBNSL */

/* Define to 1 if you have the `oe_2_0_Ada95' library (-loe_2_0_Ada95). */
/* #undef HAVE_LIBOE_2_0_ADA95 */

/* Define to 1 if you have the `pthread' library (-lpthread). */
/* #undef HAVE_LIBPTHREAD */

/* Define to 1 if you have the `rt' library (-lrt). */
/* #undef HAVE_LIBRT */

/* Define to 1 if you have the `utilities_Ada95' library (-lutilities_Ada95).
   */
/* #undef HAVE_LIBUTILITIES_ADA95 */

/* Define to 1 if you have the <limits.h> header file. */
#define HAVE_LIMITS_H 1

/* Define to 1 if you have the `localtime' function. */
#define HAVE_LOCALTIME 1

/* Define to 1 if you have the MapViewOfFile function. */
#define HAVE_MAPVEIWOFFILE 1

/* Define to 1 if you have the <math.h> header file. */
#define HAVE_MATH_H 1

/* Define to 1 if you have the <memory.h> header file. */
#define HAVE_MEMORY_H 1

/* define if the compiler implements namespaces */
#define HAVE_NAMESPACES 1

/* Define to 1 if you have the `nanosleep' function. */
/* #undef HAVE_NANOSLEEP */

/* Define to 1 if you have the <ndir.h> header file, and it defines `DIR'. */
/* #undef HAVE_NDIR_H */

/* Define to 1 if you have < netdb.h> */
/* #undef HAVE_NETDB_H */

/* Define to 1 if you have < netinet/in.h> */
/* #undef HAVE_NETINET_IN_H */

/* Define to 1 if you have <netinet/tcp.h> */
/* #undef HAVE_NETINET_TCP_H */

/* Define to 1 if you have the <netinet/tcp.h> header file */
/* #undef HAVE_NETINET_TCP_H_2 */

/* Define to 1 if you have < net/uio.h> */
/* #undef HAVE_NET_UIO_H */

/* if we can include oe.h */
/* #undef HAVE_OE_H */

/* if we can include oe.hh */
/* #undef HAVE_OE_HH */

/* Define to 1 if you have the `opendir' function. */
#define HAVE_OPENDIR 1

/* Define to 1 if you have the OpenMutex function. */
#define HAVE_OPENMUTEX 1

/* Define to 1 if you have the process.h file */
#define HAVE_PROCESS_H 1

/* Define to 1 if you have the pthread.h file */
/* #undef HAVE_PTHREAD_H */

/* Define to 1 if you have the `putenv' function. */
#define HAVE_PUTENV 1

/* Define to 1 if you have the QueryPerformanceCounter function. */
/* #define HAVE_QUERYPERFORMANCECOUNTER 1 */

/* Define to 1 if you have the QueryPerformanceFrequency function. */
/* #define HAVE_QUERYPERFORMANCEFREQUENCY 1 */

/* Define to 1 if you have the `raise' function. */
#define HAVE_RAISE 1

/* Define to 1 if you have the `readdir' function. */
#define HAVE_READDIR 1

/* Define to 1 if you have the ReleaseMutex function. */
#define HAVE_RELEASEMUTEX 1

/* Define to 1 if you have the <rpc/rpc.h> header file. */
/* #undef HAVE_RPC_RPC_H */

/* Define to 1 if you have the <rpc/types.h> header file. */
/* #undef HAVE_RPC_TYPES_H */

/* Define to 1 if you have the <rpc/xdr.h> header file. */
/* #undef HAVE_RPC_XDR_H */

/* Is this platfrom running a linux kernel with the rtai patch */
/* #undef HAVE_RTAI */

/* Is this platfrom running a linux kernel with the rtlinux patch */
/* #undef HAVE_RTL */

/* Define to 1 if you have the `sched_yield' function. */
/* #undef HAVE_SCHED_YIELD */

/* Define to 1 if you have the `select' function. */
/* #undef HAVE_SELECT */

/* Define to 1 if you have <semaphore.h> */
/* #undef HAVE_SEMAPHORE_H */

/* Define to 1 if you have the `setenv' function. */
/* #undef HAVE_SETENV */

/* Define to 1 if you have the `setitimer' function. */
/* #undef HAVE_SETITIMER */

/* Define to 1 if you have the `setsockopt' function. */
/* #undef HAVE_SETSOCKOPT */

/* Define to 1 if you have the <signal.h> header file. */
#define HAVE_SIGNAL_H 1

/* Define to 1 if you have the `sincos' function. */
/* #undef HAVE_SINCOS */

/* Define to 1 if you have the `sleep' function. */
#define HAVE_SLEEP 1

/* Define to 1 if you have the SleepEx function. */
#define HAVE_SLEEPEX 1

/* Define to 1 if you have the `snprintf' function. */
/* #undef HAVE_SNPRINTF */

/* Define to 1 if you have the `socket' function. */
/* #undef HAVE_SOCKET */

/* Define to 1 if you have the `socketpair' function. */
/* #undef HAVE_SOCKETPAIR */

/* Define to 1 if you have the socklen_t type. */
/* #undef HAVE_SOCKLEN_T_TYPE */

/* Define to 1 if you have the `sqrt' function. */
#define HAVE_SQRT 1

/* Define to 1 if you have <standards.h> */
/* #undef HAVE_STANDARDS_H */

/* define if the compiler supports ISO C++ standard library */
#define HAVE_STD 1

/* Define to 1 if you have the <stdarg.h> header file. */
#define HAVE_STDARG_H 1

/* Define to 1 if you have the <stddef.h> header file. */
#define HAVE_STDDEF_H 1

/* Define to 1 if you have the <stdint.h> header file. */
#define HAVE_STDINT_H 1

/* Define to 1 if you have the <stdio.h> header file. */
#define HAVE_STDIO_H 1

/* Define to 1 if you have the <stdlib.h> header file. */
#define HAVE_STDLIB_H 1

/* Define to 1 if you have the `strchr' function. */
#define HAVE_STRCHR 1

/* Define to 1 if you have the `strcspn' function. */
#define HAVE_STRCSPN 1

/* Define to 1 if you have the `strdup' function. */
#define HAVE_STRDUP 1

/* Define to 1 if you have the `strerror' function. */
#define HAVE_STRERROR 1

/* Define to 1 if you have the <strings.h> header file. */
/* #undef HAVE_STRINGS_H 1 */

/* Define to 1 if you have the <string.h> header file. */
#define HAVE_STRING_H 1

/* Define to 1 if you have the `strpbrk' function. */
#define HAVE_STRPBRK 1

/* Define to 1 if you have the `strrchr' function. */
#define HAVE_STRRCHR 1

/* Define to 1 if you have the `strstr' function. */
#define HAVE_STRSTR 1

/* Define to 1 if you have the `strtol' function. */
#define HAVE_STRTOL 1

/* Define to 1 if you have the `strtoul' function. */
#define HAVE_STRTOUL 1

/* Define to 1 if you have the struct iovec type. */
/* #undef HAVE_STRUCT_IOVEC_TYPE */

/* Define to 1 if you have the struct msghdr type. */
/* #undef HAVE_STRUCT_MSGHDR_TYPE */

/* Define to 1 if you have the `sync' function. */
/* #undef HAVE_SYNC */

/* Define to 1 if you have the `sysconf' function. */
/* #undef HAVE_SYSCONF */

/* Define to 1 if you have the `sysinfo' function. */
/* #undef HAVE_SYSINFO */

/* Define to 1 if you have < syslog.h> */
/* #undef HAVE_SYSLOG_H */

/* Define to 1 if you have the <sys/dir.h> header file, and it defines `DIR'.
   */
/* #undef HAVE_SYS_DIR_H */

/* Define to 1 if you have the <sys/errno.h> header file. */
/* #undef HAVE_SYS_ERRNO_H */

/* Define to 1 if you have the <sys/fcntl.h> header file. */
/* #undef HAVE_SYS_FCNTL_H */

/* Define to 1 if you have < sys/file.h> */
/* #undef HAVE_SYS_FILE_H */

/* Define to 1 if you have < sys/filio.h> */
/* #undef HAVE_SYS_FILIO_H */

/* Define to 1 if you have < sys/ioctl.h> */
/* #undef HAVE_SYS_IOCTL_H */

/* Define to 1 if you have <sys/ipc.h> */
/* #undef HAVE_SYS_IPC_H */

/* Define to 1 if you have the <sys/mman.h> header file. */
/* #undef HAVE_SYS_MMAN_H */

/* Define to 1 if you have the <sys/ndir.h> header file, and it defines `DIR'.
   */
/* #undef HAVE_SYS_NDIR_H */

/* Define to 1 if you have < sys/param.h> */
/* #undef HAVE_SYS_PARAM_H */

/* Define to 1 if you have <sys/sem.h>. */
/* #undef HAVE_SYS_SEM_H */

/* Define to 1 if you have <sys/shm.h> */
/* #undef HAVE_SYS_SHM_H */

/* Define to 1 if you have < sys/socket.h> */
/* #undef HAVE_SYS_SOCKET_H */

/* Define to 1 if you have the <sys/stat.h> header file. */
#define HAVE_SYS_STAT_H 1

/* Define to 1 if you have the <sys/sysinfo.h> header file. */
/* #undef HAVE_SYS_SYSINFO_H */

/* Define to 1 if you have < sys/systeminfo.h> */
/* #undef HAVE_SYS_SYSTEMINFO_H */

/* Define to 1 if you have < sys/time.h> */
/* #undef HAVE_SYS_TIME_H */

/* Define to 1 if you have the <sys/types.h> header file. */
#define HAVE_SYS_TYPES_H 1

/* Define to 1 if you have < sys/uio.h> */
/* #undef HAVE_SYS_UIO_H */

/* Define to 1 if you have < sys/utsname.h> */
/* #undef HAVE_SYS_UTSNAME_H */

/* Define to 1 if you have <sys/wait.h> that is POSIX.1 compatible. */
/* #undef HAVE_SYS_WAIT_H */

/* Define to 1 if you have the TerminateThread function */
#define HAVE_TERMINATETHREAD 1

/* Define to 1 if you have < termios.h> */
/* #undef HAVE_TERMIOS_H */

/* Define to 1 if you have the `time' function. */
#define HAVE_TIME 1

/* Define to 1 if you have the <time.h> header file. */
#define HAVE_TIME_H 1

/* Define to 1 if you have the <toe_services.h> header file. */
/* #undef HAVE_TOE_SERVICES_H */

/* Define to 1 if you have the <toe_services.hh> header file. */
/* #undef HAVE_TOE_SERVICES_HH */

/* Define to 1 if you have the <toolhelp.h> header file. */
/* #undef HAVE_TOOLHELP_H */

/* Define to 1 if you have the `toupper' function. */
#define HAVE_TOUPPER 1

/* Define to 1 if you have the `uname' function. */
/* #undef HAVE_UNAME */

/* Is union semun defined */
/* #undef HAVE_UNION_SEMUN */

/* Define to 1 if you have < unistd.h> */
/* #undef HAVE_UNISTD_H */

/* Define to 1 if you have the UnmapViewOfFile function. */
#define HAVE_UNMAPVEIWOFFILE 1

/* Define to 1 if you have the `usleep' function. */
/* #undef HAVE_USLEEP */

/* Define to 1 if you have the u_int type */
#define HAVE_U_INT 1

/* Define to 1 if you have the u_int type */
#define HAVE_U_LONG 1

/* Define to 1 if you have the u_short type */
#define HAVE_U_SHORT 1

/* Define to 1 if you have the <values.h> header file. */
/* #undef HAVE_VALUES_H */

/* Define to 1 if you have the `vsnprintf' function. */
/* #undef HAVE_VSNPRINTF */

/* Define to 1 if you have the WaitForSingleObject function. */
#define HAVE_WAITFORSINGLEOBJECT 1

/* Define to 1 if you have windows.h */
#define HAVE_WINDOWS_H 1

/* Define to 1 you have a working winsock2.h and ws2_32.lib system. */
#define HAVE_WINSOCK2_H 1

/* Define to 1 you have a working winsock.h and wsock32.lib system. */
/* #undef HAVE_WINSOCK_H */

/* Define to 1 if there is a working version of winver.h */
#define HAVE_WINVER_H 1

/* Define to 1 if you have the <xdr.h> header file. */
#define HAVE_XDR_H 1

/* Define to 1 if you have the Yield function. */
#define HAVE_YIELD 1

/* Define to 1 if you have the _beginthread function. */
#define HAVE__BEGINTHREAD 1

/* Define to 1 if you have the `_snprintf' function. */
#define HAVE__SNPRINTF 1

/* Define to 1 if you have the `_vsnprintf' function. */
#define HAVE__VSNPRINTF 1

/* Define to 1 if you should use the Microsoft Windows API for
   threads/sockets/IPC etc. */
#define MS_WINDOWS_API 1

/* Disable support for printing posemath stuff with iostreams */
#define NO_IOSTREAM 1
 
/* if no thread system is available */
/* #undef NO_THREADS */

/* Name of package */
#define PACKAGE "rcslib"

/* Define to the address where bug reports for this package should be sent. */
#define PACKAGE_BUGREPORT "shackle@cme.nist.gov"

/* Define to the full name of this package. */
#define PACKAGE_NAME "Real-Time Control System Library"

/* Define to the full name and version of this package. */
#define PACKAGE_STRING "Real-Time Control System Library 2004.7"

/* Define to the one symbol short name of this package. */
#define PACKAGE_TARNAME "rcslib"

/* Define to the version of this package. */
#define PACKAGE_VERSION "2004.7"

/* Should we use POSIX Semaphores */
/* #undef POSIX_SEMAPHORES */

/* Can we use POSIX semaphores? */
/* #undef POSIX_SEMAPHORES_AVAILABLE */

/* Can we use POSIX shared memory? */
/* #undef POSIX_SHAREDMEM_AVAILABLE */

/* prefix all shmem names with this string */
/* #undef POSIX_SHMEM_NAME_PREFIX */

/* if we should use POSIX threads */
/* #undef POSIX_THREADS */

/* Define to 1 if you have the ANSI C header files. */
#define STDC_HEADERS 1

/* Should we use POSIX Semaphores */
/* #undef SYS_V_SEMAPHORES */

/* Can we use SystemV semaphores? */
/* #undef SYS_V_SEMAPHORES_AVAILABLE */

/* Can we use SystemV shared memory? */
/* #undef SYS_V_SHAREDMEM_AVAILABLE */

/* Should we use POSIX Shared_Memory */
/* #undef SYS_V_SHARED_MEMORY */

/* Define to 1 if you can safely include both <sys/time.h> and <time.h>. */
/* #undef TIME_WITH_SYS_TIME 1 */

/* Define to 1 if your <sys/time.h> declares `struct tm'. */
/* #undef TM_IN_SYS_TIME */

/* Should we use POSIX Shared Memory */
/* #undef USE_POSIX_SHAREDMEM */

/* Version number of package */
#define VERSION "2009.05"

// wrap strcncpy with strncpy_s to avoid warnings.
#define HAVE_STRNCPY_S 1

// wrap snprintf with strncpy_s to avoid warnings.
#define HAVE_SNPRINTF_S 1

/* Define to empty if `const' does not conform to ANSI C. */
/* #undef const */

/* Define to `int' if <sys/types.h> doesn't define. */
#define gid_t int

/* Define to `__inline__' or `__inline' if that's what the C compiler
   calls it, or to nothing if 'inline' is not supported under any name.  */
#ifndef __cplusplus
/* #undef inline */
#endif

/* Define to `int' if <sys/types.h> does not define. */
/* #undef mode_t */

/* Define to `int' if <sys/types.h> does not define. */
/* #undef pid_t */

/* Define to `unsigned' if <sys/types.h> does not define. */
/* #undef size_t */

/* Define to `int' if <sys/types.h> doesn't define. */
#define uid_t int
