
package diagapplet.plotter;

import java.awt.Dialog;
import java.awt.Frame;
import java.util.List;
import javax.swing.JDialog;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Will Shackleford<shackle@nist.gov>
 */
public class ParseOptionsJPanel extends javax.swing.JPanel {

    /**
     * Creates new form ParseOptionsJPanel
     */
    public ParseOptionsJPanel() {
        initComponents();
    }
    
    private List<String> lines;
    
    public void updateTable() {
        String sep = this.jTextFieldFieldSeperator.getText();
        if(sep.length() == 1) {
            sep = "["+sep+"]";
        }
        String first_line = lines.get(0);
        String first_line_fa[] = first_line.split(sep);
        DefaultTableModel tm = new DefaultTableModel(first_line_fa,lines.size()-1);
        for(int i = 1; i < lines.size(); i++) {
            String line = lines.get(i);
            String fa[] = line.split(sep);
            for(int j = 0; j < fa.length; j++) {
                tm.setValueAt(fa[j], i-1, j);
            }
        }
        this.jTable1.setModel(tm);
        this.repaint();
    }
    
    public void setLines(List<String> _lines) {
        this.lines = _lines;
        if(null == lines || lines.size() < 1) {
            return;
        }
        String first_line = lines.get(0);
        if(this.jTextFieldFieldSeperator.getText().compareTo(",") == 0
                && first_line.indexOf(",") < 0 && first_line.indexOf(";") > 0) {
            this.jTextFieldFieldSeperator.setText(";");
        }
        this.updateTable();
    }
    JDialog dialog = null;
    
    static public ParseOptions ask(ParseOptions opts_in , Frame parent, List<String> _lines) {
        ParseOptions opts_out =  null;
        if(null != opts_in) {
            opts_out = opts_in.clone();
        } else {
            opts_out = new ParseOptions();
        }
        JDialog dialog = new JDialog(parent, Dialog.ModalityType.APPLICATION_MODAL);
        ParseOptionsJPanel panel = new ParseOptionsJPanel();
        panel.dialog = dialog;
        panel.jCheckBoxPlotVersusLineNumber.setSelected(opts_out.isPlotVersusLineNumber());
        panel.jTextFieldFieldSeperator.setText(opts_out.getFieldSeperator());
        panel.jTextFieldFilterPattern.setText(opts_out.getFilterPattern());
        panel.setLines(_lines);
        dialog.add(panel);
        dialog.pack();
        dialog.setVisible(true);
        opts_out.setFieldSeperator(panel.jTextFieldFieldSeperator.getText());
        opts_out.setFilterPattern(panel.jTextFieldFilterPattern.getText());
        opts_out.setPlotVersusLineNumber(panel.jCheckBoxPlotVersusLineNumber.isSelected());
        if(panel.jCheckBoxTab.isSelected()) {
            opts_out.setFieldSeperator("\t");
        }
        return opts_out;
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTextFieldFilterPattern = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldFieldSeperator = new javax.swing.JTextField();
        jButtonOk = new javax.swing.JButton();
        jCheckBoxPlotVersusLineNumber = new javax.swing.JCheckBox();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jCheckBoxTab = new javax.swing.JCheckBox();

        jLabel1.setText("Filter Pattern:");

        jLabel2.setText("Field Seperator: ");

        jTextFieldFieldSeperator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldFieldSeperatorActionPerformed(evt);
            }
        });

        jButtonOk.setText("OK");
        jButtonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOkActionPerformed(evt);
            }
        });

        jCheckBoxPlotVersusLineNumber.setText("Plot Versus Line Number");

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jCheckBoxTab.setText("Tab");
        jCheckBoxTab.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxTabActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jButtonOk))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jCheckBoxPlotVersusLineNumber)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel1))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTextFieldFilterPattern)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jTextFieldFieldSeperator, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jCheckBoxTab)
                                        .addGap(0, 38, Short.MAX_VALUE)))))
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCheckBoxPlotVersusLineNumber)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldFilterPattern, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldFieldSeperator, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jCheckBoxTab))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 277, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonOk)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jTextFieldFieldSeperatorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldFieldSeperatorActionPerformed
        this.updateTable();
    }//GEN-LAST:event_jTextFieldFieldSeperatorActionPerformed

    private void jButtonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOkActionPerformed
        if(null != dialog) {
            dialog.setVisible(false);
        }
    }//GEN-LAST:event_jButtonOkActionPerformed

    private void jCheckBoxTabActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxTabActionPerformed
        if(this.jCheckBoxTab.isSelected()) {
            this.jTextFieldFieldSeperator.setText("[\t]");
            this.jTextFieldFieldSeperator.setEditable(false);
        } else {
            this.jTextFieldFieldSeperator.setText(",");
            this.jTextFieldFieldSeperator.setEditable(true);
        }
        this.updateTable();
    }//GEN-LAST:event_jCheckBoxTabActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOk;
    private javax.swing.JCheckBox jCheckBoxPlotVersusLineNumber;
    private javax.swing.JCheckBox jCheckBoxTab;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextFieldFieldSeperator;
    private javax.swing.JTextField jTextFieldFilterPattern;
    // End of variables declaration//GEN-END:variables
}
